[leetcode] 239. Sliding Window Maximum

网友投稿 1026 2022-08-23

[leetcode] 239. Sliding Window Maximum

[leetcode] 239. Sliding Window Maximum

Description

You are given an array of integers nums, there is a sliding window of size k which is moving from the very left of the array to the very right. You can only see the k numbers in the window. Each time the sliding window moves right by one position.

Return the max sliding window.

Example 1:

Input: nums = [1,3,-1,-3,5,3,6,7], k = 3Output: [3,3,5,5,6,7]Explanation: Window position Max--------------- -----[1 3 -1] -3 5 3 6 7 3 1 [3 -1 -3] 5 3 6 7 3 1 3 [-1 -3 5] 3 6 7 5 1 3 -1 [-3 5 3] 6 7 5 1 3 -1 -3 [5 3 6] 7 6 1 3 -1 -3 5 [3 6 7] 7

Example 2:

Input: nums = [1], k = 1Output: [1]

Example 3:

Input: nums = [1,-1], k = 1Output: [1,-1]

Example 4:

Input: nums = [9,11], k = 2Output: [11]

Example 5:

Input: nums = [4,-2], k = 2Output: [4]

Constraints:

1 <= nums.length <= 105-104 <= nums[i] <= 1041 <= k <= nums.length

分析

题目的意思是:求出滑动窗口内的最大值。这道题用队列存储遍历的索引,我只能写出简单的暴力破解版本,发现AC不了。学习一下别人的思路:

如果双端队列非空,存储的值超过了windows大小,则把双端队列队头的值移除;+ 如果当前的队列非空,移除小于当前加入元素值的索引;如果当前的索引大于等于k-1,则更新最大值

代码

class Solution: def maxSlidingWindow(self, nums: List[int], k: int) -> List[int]: n=len(nums) q=deque() res=[] for i in range(n): if(q and q[0]<=i-k): # 移除队头 q.popleft() while(q and nums[i]>nums[q[-1]]): # 移除小于当前要加入元素的值的索引 q.pop() q.append(i) if(i>=k-1): # 更新最大值 res.append(nums[q[0]]) return res

参考文献

​​每日算法系列【LeetCode 239】滑动窗口最大值​​

版权声明:本文内容由网络用户投稿,版权归原作者所有,本站不拥有其著作权,亦不承担相应法律责任。如果您发现本站中有涉嫌抄袭或描述失实的内容,请联系我们jiasou666@gmail.com 处理,核实后本网站将在24小时内删除侵权内容。

上一篇:30个深度学习库:按Python和C++等10种语言分类(c语言基础学python)
下一篇:关于 Android WebView 的内存泄露问题(关于疫情的作文)
相关文章

 发表评论

暂时没有评论,来抢沙发吧~